// flow-typed signature: a576c2db8b3450ad3bee1f6e592d55aa
// flow-typed version: <<STUB>>/react-router_v^3.0.2/flow_v0.45.0

/**
 * This is an autogenerated libdef stub for:
 *
 *   'react-router'
 *
 * Fill this stub out by replacing all the `any` types.
 *
 * Once filled out, we encourage you to share your work with the
 * community by sending a pull request to:
 * https://github.com/flowtype/flow-typed
 */

import React from 'react'

import type {History, CreateHistory} from 'history'

declare module 'react-router' {
  declare type StringObject = {[key: string]: string};
  declare export type Action = 'PUSH' | 'REPLACE' | 'POP';
  declare export type RouteComponentProps = {
    router: Router,
    location: Location,
    params: Params,
    route: PlainRoute,
    routes: Array<PlainRoute>,
    routeParams: Params,
    children?: React.Element<any>,
  }
  declare export type RouteComponent = ReactClass<RouteComponentProps> | string;
  declare export type EnterHook = ((nextState: RouterState, replace: RedirectFunction) => any)
    | ((nextState: RouterState, replace: RedirectFunction, callback: (error?: ?Error) => any) => any)
  declare export type ChangeHook = ((prevState: RouterState, nextState: RouterState, replace: RedirectFunction) => any)
    | ((prevState: RouterState, nextState: RouterState, replace: RedirectFunction, callback: (error?: ?Error) => any) => any);
  declare export type Hash = string;
  declare export type LeaveHook = (prevState: RouterState) => any;
  declare export type Location = {
    pathname: Pathname;
    search: Search;
    query: Query;
    state: LocationState;
    action: Action;
    key: LocationKey;
  };
  declare export type LocationDescriptorObject = {
    pathname: Pathname;
    search?: Search;
    query?: Query;
    state?: LocationState;
  };
  declare export type LocationDescriptor = LocationDescriptorObject | Path;
  declare export type LocationKey = string;
  declare export type LocationState = ?Object;
  declare export type Params = StringObject;
  declare export type Path = string;
  declare export type Pathname = string;
  declare export type Query = StringObject;
  declare export type QueryString = string;
  declare export type Search = QueryString;
  declare export type RedirectFunction = (location: LocationDescriptor) => any;
  declare export type GetComponent = (nextState: RouterState, callback: (error: ?Error, component?: ?RouteComponent) => any) => any;
  declare export type GetComponents = (nextState: RouterState, callback: (error: ?Error, components?: ?{[name: string]: RouteComponent}) => any) => any;
  declare export type GetChildRoutes = (partialNextState: RouterState, callback: (error: ?Error, childRoutes?: ?Array<PlainRoute>) => any) => any;
  declare export type GetIndexRoute = (partialNextState: RouterState, callback: (error: ?Error, indexRoute?: ?PlainRoute) => any) => any;
  declare export type PlainRoute = {
    component?: RouteComponent,
    components?: {[name: string]: RouteComponent},
    getComponent?: GetComponent,
    getComponents?: GetComponents,
    path?: RoutePattern,
    onEnter?: EnterHook,
    onChange?: ChangeHook,
    onLeave?: LeaveHook,
    childRoutes?: Array<PlainRoute>,
    getChildRoutes?: GetChildRoutes,
    indexRoute?: PlainRoute,
    getIndexRoute?: GetIndexRoute,
  };
  declare export type RouteProps = {
    component?: RouteComponent,
    components?: {[name: string]: RouteComponent},
    getComponent?: GetComponent,
    getComponents?: GetComponents,
    path?: RoutePattern,
    onEnter?: EnterHook,
    onChange?: ChangeHook,
    onLeave?: LeaveHook,
    children?: any,
  };
  declare export class Route extends React.Component<void, RouteProps, void> {
  }
  declare export type IndexRouteProps = {
    component?: RouteComponent,
    components?: {[name: string]: RouteComponent},
    getComponent?: GetComponent,
    getComponents?: GetComponents,
    onEnter?: EnterHook,
    onChange?: ChangeHook,
    onLeave?: LeaveHook,
    children?: any,
  };
  declare export class IndexRoute extends React.Component<void, IndexRouteProps, void> {
  }
  declare export type RedirectProps = {
    from: Path,
    to: Path,
    query?: Query,
  };
  declare export class Redirect extends React.Component<void, RedirectProps, void> {
  }
  declare export type IndexRedirectProps = {
    to: Path,
    query?: Query,
  };
  declare export class IndexRedirect extends React.Component<void, IndexRedirectProps, void> {
  }
  declare export type RouteConfig = Array<PlainRoute>;
  declare export type RouteHook = (nextLocation?: Location) => any;
  declare export type RoutePattern = string;
  declare export type RouterContextProps = {
    router: Router,
    location: Location,
    routes: Array<PlainRoute>,
    params: Params,
    components: Array<RouteComponent>,
    createElement: <Props: Object>(component: ReactClass<Props>, props: Props) => React.Element<Props>,
  };
  declare export class RouterContext extends React.Component<void, RouterContextProps, void> {
  }
  declare export type RouterProps = {
    children?: Route | PlainRoute | Array<Route> | Array<PlainRoute>,
    routes?: Route | PlainRoute | Array<Route> | Array<PlainRoute>,
    history: History,
    createElement?: <Props: Object>(component: ReactClass<Props>, props: Props) => React.Element<Props>,
    onError?: (error: Error) => any,
    onUpdate?: () => any,
    render?: (props: RouterContextProps) => React.Element<any>,
  };
  declare export class Router extends React.Component<void, RouterProps, void> {
    push(location: LocationDescriptor): void;
    replace(location: LocationDescriptor): void;
    go(n: number): void;
    goBack(): void;
    goForward(): void;
    setRouteLeaveHook(route: PlainRoute, hook: RouteHook): Function;
    isActive(location: LocationDescriptor, indexOnly: boolean): void;
  }
  declare export type RouterState = {
    location: Location;
    routes: Array<PlainRoute>;
    params: Params;
    components: Array<RouteComponent>;
  };
  declare export type LinkProps = {
    to: LocationDescriptor,
    activeClassName?: string,
    activeStyle?: Object,
    onClick?: (e: MouseEvent) => any,
    onlyActiveOnIndex?: boolean,
    target?: string,
  }
  declare export class Link extends React.Component<void, LinkProps, void> {
  }
  declare export class IndexLink extends React.Component<void, LinkProps, void> {
  }
  declare export function withRouter<Props: RouteComponentProps>(
    comp: ReactClass<Props>
  ): ReactClass<$Diff<Props, RouteComponentProps>>;

  declare export var browserHistory: History;
  declare export var hashHistory: History;
  declare export function createMemoryHistory(location?: LocationDescriptor): History;
  declare export function useRouterHistory(createHistory: CreateHistory): CreateHistory;
  declare export type MatchOptions = {
    routes: PlainRoute | Array<PlainRoute>,
    location: LocationDescriptor,
    history?: History,
  };
  declare export function match(options: MatchOptions, callback: (error: ?Error, redirectLocation?: Location, renderProps?: RouterContextProps) => any): void;
  declare export function createRoutes(routes: Route | PlainRoute | Array<PlainRoute>): Array<PlainRoute>;
}

/**
 * We include stubs for each file inside this npm package in case you need to
 * require those files directly. Feel free to delete any files that aren't
 * needed.
 */
declare module 'react-router/es/applyRouterMiddleware' {
  declare module.exports: any;
}

declare module 'react-router/es/AsyncUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/browserHistory' {
  declare module.exports: any;
}

declare module 'react-router/es/computeChangedRoutes' {
  declare module.exports: any;
}

declare module 'react-router/es/ContextUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/createMemoryHistory' {
  declare module.exports: any;
}

declare module 'react-router/es/createRouterHistory' {
  declare module.exports: any;
}

declare module 'react-router/es/createTransitionManager' {
  declare module.exports: any;
}

declare module 'react-router/es/getComponents' {
  declare module.exports: any;
}

declare module 'react-router/es/getRouteParams' {
  declare module.exports: any;
}

declare module 'react-router/es/hashHistory' {
  declare module.exports: any;
}

declare module 'react-router/es/index' {
  declare module.exports: any;
}

declare module 'react-router/es/IndexLink' {
  declare module.exports: any;
}

declare module 'react-router/es/IndexRedirect' {
  declare module.exports: any;
}

declare module 'react-router/es/IndexRoute' {
  declare module.exports: any;
}

declare module 'react-router/es/InternalPropTypes' {
  declare module.exports: any;
}

declare module 'react-router/es/isActive' {
  declare module.exports: any;
}

declare module 'react-router/es/Link' {
  declare module.exports: any;
}

declare module 'react-router/es/match' {
  declare module.exports: any;
}

declare module 'react-router/es/matchRoutes' {
  declare module.exports: any;
}

declare module 'react-router/es/PatternUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/PromiseUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/PropTypes' {
  declare module.exports: any;
}

declare module 'react-router/es/Redirect' {
  declare module.exports: any;
}

declare module 'react-router/es/Route' {
  declare module.exports: any;
}

declare module 'react-router/es/Router' {
  declare module.exports: any;
}

declare module 'react-router/es/RouterContext' {
  declare module.exports: any;
}

declare module 'react-router/es/RouterUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/routerWarning' {
  declare module.exports: any;
}

declare module 'react-router/es/RouteUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/TransitionUtils' {
  declare module.exports: any;
}

declare module 'react-router/es/useRouterHistory' {
  declare module.exports: any;
}

declare module 'react-router/es/withRouter' {
  declare module.exports: any;
}

declare module 'react-router/lib/applyRouterMiddleware' {
  declare module.exports: any;
}

declare module 'react-router/lib/AsyncUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/browserHistory' {
  declare module.exports: any;
}

declare module 'react-router/lib/computeChangedRoutes' {
  declare module.exports: any;
}

declare module 'react-router/lib/ContextUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/createMemoryHistory' {
  declare module.exports: any;
}

declare module 'react-router/lib/createRouterHistory' {
  declare module.exports: any;
}

declare module 'react-router/lib/createTransitionManager' {
  declare module.exports: any;
}

declare module 'react-router/lib/getComponents' {
  declare module.exports: any;
}

declare module 'react-router/lib/getRouteParams' {
  declare module.exports: any;
}

declare module 'react-router/lib/hashHistory' {
  declare module.exports: any;
}

declare module 'react-router/lib/index' {
  declare module.exports: any;
}

declare module 'react-router/lib/IndexLink' {
  declare module.exports: any;
}

declare module 'react-router/lib/IndexRedirect' {
  declare module.exports: any;
}

declare module 'react-router/lib/IndexRoute' {
  declare module.exports: any;
}

declare module 'react-router/lib/InternalPropTypes' {
  declare module.exports: any;
}

declare module 'react-router/lib/isActive' {
  declare module.exports: any;
}

declare module 'react-router/lib/Link' {
  declare module.exports: any;
}

declare module 'react-router/lib/match' {
  declare module.exports: any;
}

declare module 'react-router/lib/matchRoutes' {
  declare module.exports: any;
}

declare module 'react-router/lib/PatternUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/PromiseUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/PropTypes' {
  declare module.exports: any;
}

declare module 'react-router/lib/Redirect' {
  declare module.exports: any;
}

declare module 'react-router/lib/Route' {
  declare module.exports: any;
}

declare module 'react-router/lib/Router' {
  declare module.exports: any;
}

declare module 'react-router/lib/RouterContext' {
  declare module.exports: any;
}

declare module 'react-router/lib/RouterUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/routerWarning' {
  declare module.exports: any;
}

declare module 'react-router/lib/RouteUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/TransitionUtils' {
  declare module.exports: any;
}

declare module 'react-router/lib/useRouterHistory' {
  declare module.exports: any;
}

declare module 'react-router/lib/withRouter' {
  declare module.exports: any;
}

declare module 'react-router/umd/ReactRouter' {
  declare module.exports: any;
}

declare module 'react-router/umd/ReactRouter.min' {
  declare module.exports: any;
}

// Filename aliases
declare module 'react-router/es/applyRouterMiddleware.js' {
  declare module.exports: $Exports<'react-router/es/applyRouterMiddleware'>;
}
declare module 'react-router/es/AsyncUtils.js' {
  declare module.exports: $Exports<'react-router/es/AsyncUtils'>;
}
declare module 'react-router/es/browserHistory.js' {
  declare module.exports: $Exports<'react-router/es/browserHistory'>;
}
declare module 'react-router/es/computeChangedRoutes.js' {
  declare module.exports: $Exports<'react-router/es/computeChangedRoutes'>;
}
declare module 'react-router/es/ContextUtils.js' {
  declare module.exports: $Exports<'react-router/es/ContextUtils'>;
}
declare module 'react-router/es/createMemoryHistory.js' {
  declare module.exports: $Exports<'react-router/es/createMemoryHistory'>;
}
declare module 'react-router/es/createRouterHistory.js' {
  declare module.exports: $Exports<'react-router/es/createRouterHistory'>;
}
declare module 'react-router/es/createTransitionManager.js' {
  declare module.exports: $Exports<'react-router/es/createTransitionManager'>;
}
declare module 'react-router/es/getComponents.js' {
  declare module.exports: $Exports<'react-router/es/getComponents'>;
}
declare module 'react-router/es/getRouteParams.js' {
  declare module.exports: $Exports<'react-router/es/getRouteParams'>;
}
declare module 'react-router/es/hashHistory.js' {
  declare module.exports: $Exports<'react-router/es/hashHistory'>;
}
declare module 'react-router/es/index.js' {
  declare module.exports: $Exports<'react-router/es/index'>;
}
declare module 'react-router/es/IndexLink.js' {
  declare module.exports: $Exports<'react-router/es/IndexLink'>;
}
declare module 'react-router/es/IndexRedirect.js' {
  declare module.exports: $Exports<'react-router/es/IndexRedirect'>;
}
declare module 'react-router/es/IndexRoute.js' {
  declare module.exports: $Exports<'react-router/es/IndexRoute'>;
}
declare module 'react-router/es/InternalPropTypes.js' {
  declare module.exports: $Exports<'react-router/es/InternalPropTypes'>;
}
declare module 'react-router/es/isActive.js' {
  declare module.exports: $Exports<'react-router/es/isActive'>;
}
declare module 'react-router/es/Link.js' {
  declare module.exports: $Exports<'react-router/es/Link'>;
}
declare module 'react-router/es/match.js' {
  declare module.exports: $Exports<'react-router/es/match'>;
}
declare module 'react-router/es/matchRoutes.js' {
  declare module.exports: $Exports<'react-router/es/matchRoutes'>;
}
declare module 'react-router/es/PatternUtils.js' {
  declare module.exports: $Exports<'react-router/es/PatternUtils'>;
}
declare module 'react-router/es/PromiseUtils.js' {
  declare module.exports: $Exports<'react-router/es/PromiseUtils'>;
}
declare module 'react-router/es/PropTypes.js' {
  declare module.exports: $Exports<'react-router/es/PropTypes'>;
}
declare module 'react-router/es/Redirect.js' {
  declare module.exports: $Exports<'react-router/es/Redirect'>;
}
declare module 'react-router/es/Route.js' {
  declare module.exports: $Exports<'react-router/es/Route'>;
}
declare module 'react-router/es/Router.js' {
  declare module.exports: $Exports<'react-router/es/Router'>;
}
declare module 'react-router/es/RouterContext.js' {
  declare module.exports: $Exports<'react-router/es/RouterContext'>;
}
declare module 'react-router/es/RouterUtils.js' {
  declare module.exports: $Exports<'react-router/es/RouterUtils'>;
}
declare module 'react-router/es/routerWarning.js' {
  declare module.exports: $Exports<'react-router/es/routerWarning'>;
}
declare module 'react-router/es/RouteUtils.js' {
  declare module.exports: $Exports<'react-router/es/RouteUtils'>;
}
declare module 'react-router/es/TransitionUtils.js' {
  declare module.exports: $Exports<'react-router/es/TransitionUtils'>;
}
declare module 'react-router/es/useRouterHistory.js' {
  declare module.exports: $Exports<'react-router/es/useRouterHistory'>;
}
declare module 'react-router/es/withRouter.js' {
  declare module.exports: $Exports<'react-router/es/withRouter'>;
}
declare module 'react-router/lib/applyRouterMiddleware.js' {
  declare module.exports: $Exports<'react-router/lib/applyRouterMiddleware'>;
}
declare module 'react-router/lib/AsyncUtils.js' {
  declare module.exports: $Exports<'react-router/lib/AsyncUtils'>;
}
declare module 'react-router/lib/browserHistory.js' {
  declare module.exports: $Exports<'react-router/lib/browserHistory'>;
}
declare module 'react-router/lib/computeChangedRoutes.js' {
  declare module.exports: $Exports<'react-router/lib/computeChangedRoutes'>;
}
declare module 'react-router/lib/ContextUtils.js' {
  declare module.exports: $Exports<'react-router/lib/ContextUtils'>;
}
declare module 'react-router/lib/createMemoryHistory.js' {
  declare module.exports: $Exports<'react-router/lib/createMemoryHistory'>;
}
declare module 'react-router/lib/createRouterHistory.js' {
  declare module.exports: $Exports<'react-router/lib/createRouterHistory'>;
}
declare module 'react-router/lib/createTransitionManager.js' {
  declare module.exports: $Exports<'react-router/lib/createTransitionManager'>;
}
declare module 'react-router/lib/getComponents.js' {
  declare module.exports: $Exports<'react-router/lib/getComponents'>;
}
declare module 'react-router/lib/getRouteParams.js' {
  declare module.exports: $Exports<'react-router/lib/getRouteParams'>;
}
declare module 'react-router/lib/hashHistory.js' {
  declare module.exports: $Exports<'react-router/lib/hashHistory'>;
}
declare module 'react-router/lib/index.js' {
  declare module.exports: $Exports<'react-router/lib/index'>;
}
declare module 'react-router/lib/IndexLink.js' {
  declare module.exports: $Exports<'react-router/lib/IndexLink'>;
}
declare module 'react-router/lib/IndexRedirect.js' {
  declare module.exports: $Exports<'react-router/lib/IndexRedirect'>;
}
declare module 'react-router/lib/IndexRoute.js' {
  declare module.exports: $Exports<'react-router/lib/IndexRoute'>;
}
declare module 'react-router/lib/InternalPropTypes.js' {
  declare module.exports: $Exports<'react-router/lib/InternalPropTypes'>;
}
declare module 'react-router/lib/isActive.js' {
  declare module.exports: $Exports<'react-router/lib/isActive'>;
}
declare module 'react-router/lib/Link.js' {
  declare module.exports: $Exports<'react-router/lib/Link'>;
}
declare module 'react-router/lib/match.js' {
  declare module.exports: $Exports<'react-router/lib/match'>;
}
declare module 'react-router/lib/matchRoutes.js' {
  declare module.exports: $Exports<'react-router/lib/matchRoutes'>;
}
declare module 'react-router/lib/PatternUtils.js' {
  declare module.exports: $Exports<'react-router/lib/PatternUtils'>;
}
declare module 'react-router/lib/PromiseUtils.js' {
  declare module.exports: $Exports<'react-router/lib/PromiseUtils'>;
}
declare module 'react-router/lib/PropTypes.js' {
  declare module.exports: $Exports<'react-router/lib/PropTypes'>;
}
declare module 'react-router/lib/Redirect.js' {
  declare module.exports: $Exports<'react-router/lib/Redirect'>;
}
declare module 'react-router/lib/Route.js' {
  declare module.exports: $Exports<'react-router/lib/Route'>;
}
declare module 'react-router/lib/Router.js' {
  declare module.exports: $Exports<'react-router/lib/Router'>;
}
declare module 'react-router/lib/RouterContext.js' {
  declare module.exports: $Exports<'react-router/lib/RouterContext'>;
}
declare module 'react-router/lib/RouterUtils.js' {
  declare module.exports: $Exports<'react-router/lib/RouterUtils'>;
}
declare module 'react-router/lib/routerWarning.js' {
  declare module.exports: $Exports<'react-router/lib/routerWarning'>;
}
declare module 'react-router/lib/RouteUtils.js' {
  declare module.exports: $Exports<'react-router/lib/RouteUtils'>;
}
declare module 'react-router/lib/TransitionUtils.js' {
  declare module.exports: $Exports<'react-router/lib/TransitionUtils'>;
}
declare module 'react-router/lib/useRouterHistory.js' {
  declare module.exports: $Exports<'react-router/lib/useRouterHistory'>;
}
declare module 'react-router/lib/withRouter.js' {
  declare module.exports: $Exports<'react-router/lib/withRouter'>;
}
declare module 'react-router/umd/ReactRouter.js' {
  declare module.exports: $Exports<'react-router/umd/ReactRouter'>;
}
declare module 'react-router/umd/ReactRouter.min.js' {
  declare module.exports: $Exports<'react-router/umd/ReactRouter.min'>;
}
