'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = createChildRoutesSelector;

var _lodash = require('lodash.defaults');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.memoize');

var _lodash4 = _interopRequireDefault(_lodash3);

var _reselect = require('reselect');

var _wrapRoute = require('./wrapRoute');

var _wrapRoute2 = _interopRequireDefault(_wrapRoute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babelPluginFlowReactPropTypes_proptype_Store = require('redux').babelPluginFlowReactPropTypes_proptype_Store || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_PlainRoute = require('react-router').babelPluginFlowReactPropTypes_proptype_PlainRoute || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_Feature = require('redux-features').babelPluginFlowReactPropTypes_proptype_Feature || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_Options = require('./createChildRoutesSelector').babelPluginFlowReactPropTypes_proptype_Options || require('prop-types').any;

var babelPluginFlowReactPropTypes_proptype_GetRoutes = require('./wrapRoute').babelPluginFlowReactPropTypes_proptype_GetRoutes || require('prop-types').any;

var optionsDefaults = {
  getFeatureStates: function getFeatureStates(state) {
    return state.featureStates;
  },
  getFeatures: function getFeatures(state) {
    return state.features;
  },
  getFeatureName: function getFeatureName(featureId) {
    return featureId;
  }
};

function createChildRoutesSelector(options) {
  options = (0, _lodash2.default)(options, optionsDefaults);
  var _options = options,
      getFeatures = _options.getFeatures,
      getFeatureName = _options.getFeatureName;


  return function (getRoutes) {
    var selectFeatureRoutes = (0, _lodash4.default)(function (featureId) {
      return (0, _reselect.createSelector)(function (feature, store) {
        return store;
      }, function (feature) {
        return getFeatureName(featureId, feature);
      }, getRoutes, function (store, featureName, routes) {
        function wrapSingleRoute(route) {
          return (0, _wrapRoute2.default)((0, _extends3.default)({}, options, {
            store: store,
            route: route,
            getRoutes: getRoutes,
            featureId: featureId,
            featureName: featureName
          }));
        }

        if (Array.isArray(routes)) return routes.map(wrapSingleRoute);else if (routes) return [wrapSingleRoute(routes)];
      });
    });

    var lastFeatures = void 0,
        lastChildRoutes = void 0;
    return function selectChildRoutes(store) {
      var features = getFeatures(store.getState());
      if (features === lastFeatures) return lastChildRoutes;
      lastFeatures = features;

      lastChildRoutes = [];
      for (var _featureId in features) {
        var _lastChildRoutes;

        var featureRoutes = selectFeatureRoutes(_featureId)(features[_featureId], store);
        if (Array.isArray(featureRoutes)) (_lastChildRoutes = lastChildRoutes).push.apply(_lastChildRoutes, (0, _toConsumableArray3.default)(featureRoutes));
      }
      return lastChildRoutes;
    };
  };
}